/*
memallocfree3_gpu.cu (CUDA)

alloc and free
(3) near3d
*/

#include "ofd.h"
#include "ofd_cuda.h"
#include "ofd_prototype.h"

void memalloc3_gpu()
{
	if ((NN > 0) && (NFreq2 > 0)) {
		size_t size = NN * NFreq2 * sizeof(float *);
/*
		cEx_r = (float *)malloc(size);
		cEx_i = (float *)malloc(size);
		cEy_r = (float *)malloc(size);
		cEy_i = (float *)malloc(size);
		cEz_r = (float *)malloc(size);
		cEz_i = (float *)malloc(size);
		cHx_r = (float *)malloc(size);
		cHx_i = (float *)malloc(size);
		cHy_r = (float *)malloc(size);
		cHy_i = (float *)malloc(size);
		cHz_r = (float *)malloc(size);
		cHz_i = (float *)malloc(size);

		memset(cEx_r, 0, size);
		memset(cEx_i, 0, size);
		memset(cEy_r, 0, size);
		memset(cEy_i, 0, size);
		memset(cEz_r, 0, size);
		memset(cEz_i, 0, size);
		memset(cHx_r, 0, size);
		memset(cHx_i, 0, size);
		memset(cHy_r, 0, size);
		memset(cHy_i, 0, size);
		memset(cHz_r, 0, size);
		memset(cHz_i, 0, size);
*/
		cuda_malloc(GPU, UM, (void **)&d_cEx_r, size);
		cuda_malloc(GPU, UM, (void **)&d_cEy_r, size);
		cuda_malloc(GPU, UM, (void **)&d_cEz_r, size);
		cuda_malloc(GPU, UM, (void **)&d_cHx_r, size);
		cuda_malloc(GPU, UM, (void **)&d_cHy_r, size);
		cuda_malloc(GPU, UM, (void **)&d_cHz_r, size);
		cuda_malloc(GPU, UM, (void **)&d_cEx_i, size);
		cuda_malloc(GPU, UM, (void **)&d_cEy_i, size);
		cuda_malloc(GPU, UM, (void **)&d_cEz_i, size);
		cuda_malloc(GPU, UM, (void **)&d_cHx_i, size);
		cuda_malloc(GPU, UM, (void **)&d_cHy_i, size);
		cuda_malloc(GPU, UM, (void **)&d_cHz_i, size);
	}
}


void memfree3_gpu()
{
	cuda_free(GPU, d_cEx_r);
	cuda_free(GPU, d_cEy_r);
	cuda_free(GPU, d_cEz_r);
	cuda_free(GPU, d_cHx_r);
	cuda_free(GPU, d_cHy_r);
	cuda_free(GPU, d_cHz_r);
	cuda_free(GPU, d_cEx_i);
	cuda_free(GPU, d_cEy_i);
	cuda_free(GPU, d_cEz_i);
	cuda_free(GPU, d_cHx_i);
	cuda_free(GPU, d_cHy_i);
	cuda_free(GPU, d_cHz_i);
}

